// -*- C++ -*-
/*!
 * @file  OUTPUT_TEST.cpp
 * @brief Data output test
 * @date $Date$
 *
 * $Id$
 */

#include "OUTPUT_TEST.h"

// Module specification
// <rtc-template block="module_spec">
static const char* output_test_spec[] =
  {
    "implementation_id", "OUTPUT_TEST",
    "type_name",         "OUTPUT_TEST",
    "description",       "Data output test",
    "version",           "0.1",
    "vendor",            "Vstone",
    "category",          "Test",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "0",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
OUTPUT_TEST::OUTPUT_TEST(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_an1Out("an1", m_an1),
    m_an2Out("an2", m_an2),
    m_btnOut("btn", m_btn)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
OUTPUT_TEST::~OUTPUT_TEST()
{
}



RTC::ReturnCode_t OUTPUT_TEST::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  addOutPort("an1", m_an1Out);
  addOutPort("an2", m_an2Out);
  addOutPort("btn", m_btnOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t OUTPUT_TEST::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_TEST::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_TEST::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_TEST::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_TEST::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t OUTPUT_TEST::onExecute(RTC::UniqueId ec_id)
{
  //CPU{[hƐڑ
  if(CWRC_Connect()){

    //E̐ԊOZTAyу{^͂̓ǂݍ݂w
    CWRC_ReadMemMap(0x1a,4);
    CWRC_ReadMemMap(0x2c,2);

    //f[^̓ǂݍ݂s
    CWRC_ReadExecute();

    //ǂݍ񂾃f[^Ao̓|[gɒ`ꂽ\̂ɑ
    m_an1.data = wrc_mem_uw(0x1a);
    m_an2.data = wrc_mem_uw(0x1c);
    m_btn.data = wrc_mem_uw(0x2c);

    //o̓|[gf[^𑗂
    m_an1Out.write();
    m_an2Out.write();
    m_btnOut.write();

    //ڑؒf
    CWRC_Disconnect();
  }
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t OUTPUT_TEST::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_TEST::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_TEST::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_TEST::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t OUTPUT_TEST::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void OUTPUT_TESTInit(RTC::Manager* manager)
  {
    coil::Properties profile(output_test_spec);
    manager->registerFactory(profile,
                             RTC::Create<OUTPUT_TEST>,
                             RTC::Delete<OUTPUT_TEST>);
  }
  
};


